# Change Log

## Unreleased (2021-06-30)

**Features**

- Custom None nullable type in generated Kotlin data class [\#358](https://github.com/wuseal/JsonToKotlinClass/issues/358)
- Add buildFromJson function into data class to build data class object from JSONObject [\#348](https://github.com/wuseal/JsonToKotlinClass/issues/348)

## [3.7.1\-EAP\-3](https://github.com/wuseal/JsonToKotlinClass/tree/3.7.1-EAP-3) (2021-05-25)
[View commits](https://github.com/wuseal/JsonToKotlinClass/compare/3.7.0...3.7.1-EAP-3)


## [3.7.0](https://github.com/wuseal/JsonToKotlinClass/tree/3.7.0) (2021-05-18)
[View commits](https://github.com/wuseal/JsonToKotlinClass/compare/3.7.0-EAP-3...3.7.0)

**Bugfix**

- Field value in Double format generates Int instead [\#334](https://github.com/wuseal/JsonToKotlinClass/issues/334)
- Handling already escaped quotes \\" with "Force init Default Value With Origin Json Value" checked [\#301](https://github.com/wuseal/JsonToKotlinClass/issues/301)
- Not escaping kotlin keywords [\#290](https://github.com/wuseal/JsonToKotlinClass/issues/290)

**Enhancement**

- Add an option to switch autodetect JSONSchema [\#223](https://github.com/wuseal/JsonToKotlinClass/issues/223)
- Generated Parcelable data class uses deprecated annotation from package android.parcel [\#335](https://github.com/wuseal/JsonToKotlinClass/issues/335)

**Features**

- Support no parameter constructor [\#291](https://github.com/wuseal/JsonToKotlinClass/issues/291)
- class prefix support [\#322](https://github.com/wuseal/JsonToKotlinClass/issues/322)
- provide a switch case for sending analytics [\#296](https://github.com/wuseal/JsonToKotlinClass/issues/296)

## [V3.6.1](https://github.com/wuseal/JsonToKotlinClass/tree/V3.6.1) (2020-03-25)
[View commits](https://github.com/wuseal/JsonToKotlinClass/compare/V3.6.0...V3.6.1)

**Bugfix**

- Wrong generation of data class [\#269](https://github.com/wuseal/JsonToKotlinClass/issues/269)
- Generated model not matching JSON [\#241](https://github.com/wuseal/JsonToKotlinClass/issues/241)
- java.lang.IllegalStateException: Can't generate Kotlin Data Class from a no JSON Object [\#243](https://github.com/wuseal/JsonToKotlinClass/issues/243)

**Enhancement**

- JsonSchema doesn't generate class  [\#222](https://github.com/wuseal/JsonToKotlinClass/issues/222)

**Features**

- Generate Kotlin classes from JSON Schema [\#108](https://github.com/wuseal/JsonToKotlinClass/issues/108)
- Useless \`data\` modifier [\#263](https://github.com/wuseal/JsonToKotlinClass/issues/263)

## [V3.6.0](https://github.com/wuseal/JsonToKotlinClass/tree/V3.6.0) (2020-03-19)
[View commits](https://github.com/wuseal/JsonToKotlinClass/compare/3.6.0-EAP-2...V3.6.0)


## [V3.5.1](https://github.com/wuseal/JsonToKotlinClass/tree/V3.5.1) (2019-11-17)
[View commits](https://github.com/wuseal/JsonToKotlinClass/compare/3.5.1-EAP...V3.5.1)

**Features**

- Respect dot as a word separator [\#249](https://github.com/wuseal/JsonToKotlinClass/issues/249)
- Making default values as values from Json with option to disable [\#84](https://github.com/wuseal/JsonToKotlinClass/issues/84)

## [V3.5.0](https://github.com/wuseal/JsonToKotlinClass/tree/V3.5.0) (2019-09-04)
[View commits](https://github.com/wuseal/JsonToKotlinClass/compare/3.5.0-EAP...V3.5.0)

**Bugfix**

- a redundant comma appears after data class generated without sort by alphabet [\#225](https://github.com/wuseal/JsonToKotlinClass/issues/225)
- json生成kotlin类出现错误格式 [\#224](https://github.com/wuseal/JsonToKotlinClass/issues/224)

**Features**

- \[Feature Request\]Add an option that force primitive type to be non\-nullable into Extensions Tab [\#234](https://github.com/wuseal/JsonToKotlinClass/issues/234)

## [V3.4.1](https://github.com/wuseal/JsonToKotlinClass/tree/V3.4.1) (2019-08-05)
[View commits](https://github.com/wuseal/JsonToKotlinClass/compare/V3.4.0...V3.4.1)


## [V3.4.0](https://github.com/wuseal/JsonToKotlinClass/tree/V3.4.0) (2019-07-31)
[View commits](https://github.com/wuseal/JsonToKotlinClass/compare/3.4.0-EAP-2...V3.4.0)


## [V3.3.0](https://github.com/wuseal/JsonToKotlinClass/tree/V3.3.0) (2019-06-30)
[View commits](https://github.com/wuseal/JsonToKotlinClass/compare/3.3.0-EAP-2...V3.3.0)

**Features**

- \[Feature Request\]Suffix appending behind of all class name [\#165](https://github.com/wuseal/JsonToKotlinClass/issues/165)

## [v3.2.0](https://github.com/wuseal/JsonToKotlinClass/tree/v3.2.0) (2019-04-26)
[View commits](https://github.com/wuseal/JsonToKotlinClass/compare/v3.2.0-EAP...v3.2.0)


## [V3.2.0](https://github.com/wuseal/JsonToKotlinClass/tree/V3.2.0) (2019-04-26)
[View commits](https://github.com/wuseal/JsonToKotlinClass/compare/v3.2.0...V3.2.0)


## [V3.0.1](https://github.com/wuseal/JsonToKotlinClass/tree/V3.0.1) (2019-03-03)
[View commits](https://github.com/wuseal/JsonToKotlinClass/compare/V3.0.0...V3.0.1)

**Bugfix**

- java.lang.IndexOutOfBoundsException: Index: 1, Size: 1 [\#89](https://github.com/wuseal/JsonToKotlinClass/issues/89)
- please test this data   \-\>   repetition \-\>class [\#82](https://github.com/wuseal/JsonToKotlinClass/issues/82)
- "Import statements" go after class declaration [\#83](https://github.com/wuseal/JsonToKotlinClass/issues/83)
- JSON converstion not works as expected [\#90](https://github.com/wuseal/JsonToKotlinClass/issues/90)

**Features**

- JSON input from file [\#76](https://github.com/wuseal/JsonToKotlinClass/issues/76)

## [V3.0.0](https://github.com/wuseal/JsonToKotlinClass/tree/V3.0.0) (2019-01-18)
[View commits](https://github.com/wuseal/JsonToKotlinClass/compare/V3.0-EAP-2...V3.0.0)

